﻿using C1.WPF.DataFilter;
using FilterEditorDemo.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FilterEditorDemo.CustomControls
{
    /// <summary>
    /// Interaction logic for RuleEditorControl.xaml
    /// </summary>
    public partial class RuleEditorControl : UserControl
    {
        public Rule Rule { get; private set; }
        public event EventHandler RuleChanged;
        public RuleEditorControl(Rule rule, IEnumerable source)
        {
            InitializeComponent();
            this.Rule = rule;
            this.DataContext = Rule;

            filterEditor.Expression = Rule.Expression;
            filterEditor.ItemsSource = source;
        }
        private void FilterEditor_Loaded(object sender, RoutedEventArgs e)
        {
            var applyButton = filterEditor.Template.FindName("Apply", filterEditor) as Button;
            var resetButton = filterEditor.Template.FindName("Reset", filterEditor) as Button;

            applyButton.PreviewMouseDown += (ss, ee) => { OnRuleChanged(); };
            resetButton.PreviewMouseDown += (ss, ee) => { OnRuleChanged(); };
        }

        private void OnRuleChanged()
        {
            Rule.Expression = filterEditor.Expression;
            RuleChanged?.Invoke(this, EventArgs.Empty);
        }
    }
}
