﻿using C1.DataCollection;
using C1.DataFilter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FilterEditorDemo.Models
{
    public class Rule : INotifyPropertyChanged
    {
        private ObservableCollection<Rule> _child = new ObservableCollection<Rule>();
        private string _name;
        private bool _isExpanded, _isSelected;

        #region Object Model
        public string Name { get { return _name; } set { _name = value; OnPropertyChanged(nameof(Name)); } }
        public bool IsExpanded { get { return _isExpanded; } set { _isExpanded = value; OnPropertyChanged(nameof(IsExpanded)); } }
        public bool IsSelected { get { return _isSelected; } set { _isSelected = value; OnPropertyChanged(nameof(IsSelected)); } }
        public bool CanDelete { get; set; } = true;
        public Expression Expression { get; set; }
        public ObservableCollection<Rule> ChildRules { get { return _child; } }
        public Rule ParentRule { get; set; }
        public Expression CombinedExpression
        {
            get
            {
                var combination = new CombinationExpression() { FilterCombination = FilterCombination.And };
                if (this.Expression != null)
                    combination.Expressions.Add(this.Expression);
                if (this.ParentRule?.Expression != null)
                    combination.Expressions.Add(this.ParentRule?.CombinedExpression);
                return combination;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        #endregion

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
